// JavaScript Documentvar
  var myBookMarkJs = {
	  setStartChecked :function(){
		var myButton = document.getElementById('myTabBookmarks-Menu');
		myButton.setAttribute('checked', 'true');
	  },
	  
	  onPanelClose :function(CloseType){
		var myPanel=document.getElementById('myPanel');
		if(myPanel.state == "closed" || CloseType=="OpenSideBar"){
			var myButton = document.getElementById('myTabBookmarks-Menu');			
			myButton.setAttribute('checked', 'false');	
			gBrowser.focus();
			myBookMarkJs.isFocus=false ;			
		}
	  },
	  
	  SetPanelHeight: function(myPanel){
		var boxHeight=document.getElementById('appcontent').boxObject.height * 0.85 ;
		var myBox=document.getElementById('myPanelBox',myPanel);
		myBox.setAttribute('height', boxHeight);	
	  },
	  
	  OpenBookMark : function(myPanel){
		var myBookMarksTabs=document.getElementById('myBookMarksTabs',myPanel);
		if(myBookMarksTabs.selectedIndex==-1) myBookMarksTabs.selectedIndex=0 ;
		if(myPanel.getAttribute('firstOpen')=='true'){			
			myBookMarksTabs.selectedIndex=0 ;
		}
		if(myBookMarksTabs.selectedIndex==0) myBookMarkJs.BookMarkFillData() ;
		else if(myBookMarksTabs.selectedIndex==1) myBookMarkJs.HistoryFillData() ;
	  },
	  
	  BookMarkFillData : function(){
		var tree = document.getElementById('myBookmarks-view');		
		tree.place ='place:queryType=1&folder=' + window.top.PlacesUIUtils.allBookmarksFolderId;
		var mySearchbox = document.getElementById('myBookmarkSearch-box');	
		var aSearchString=mySearchbox.value	;
		if (!aSearchString)
			tree.place = tree.place;
		else
		tree.applyFilter(aSearchString,
			[PlacesUtils.bookmarksMenuFolderId,
			PlacesUtils.unfiledBookmarksFolderId,
			PlacesUtils.toolbarFolderId]); 		  
	  },
	  
	  BookMarkSearch : function(aInput){
		var aSearchString=aInput.value ;        
		var tree = document.getElementById('myBookmarks-view');
		if (!aSearchString)
		tree.place = tree.place;
		else
		tree.applyFilter(aSearchString,
			[PlacesUtils.bookmarksMenuFolderId,
			PlacesUtils.unfiledBookmarksFolderId,
			PlacesUtils.toolbarFolderId]); 		  
	 }, 
	  
	  HistoryFillData : function(){
		var gmyHistoryTree;
		var gSearchBox;
		var gHistoryGrouping = '';
		var gSearching = false;
		function HistorySidebarInit()
		{
			gHistoryTree = document.getElementById('myHistoryTree');
			gHistoryGrouping = document.getElementById('viewButton').getAttribute('selectedsort1');
			
			if (gHistoryGrouping == 'site')
				document.getElementById('bysite').setAttribute('checked', 'true');
			else if (gHistoryGrouping == 'visited') 
				document.getElementById('byvisited').setAttribute('checked', 'true');
			else if (gHistoryGrouping == 'lastvisited')
				document.getElementById('bylastvisited').setAttribute('checked', 'true');
			else if (gHistoryGrouping == 'dayandsite')
				document.getElementById('bydayandsite').setAttribute('checked', 'true');
			else
				document.getElementById('byday').setAttribute('checked', 'true');			

			gSearchBox = document.getElementById('search-box');
		  searchHistory(gSearchBox.value);				
		}
		
		function searchHistory(aInput)
		{
		  var query = PlacesUtils.history.getNewQuery();
		  var options = PlacesUtils.history.getNewQueryOptions();
		
		  const NHQO = Ci.nsINavHistoryQueryOptions;
		  var sortingMode;
		  var resultType;
		
		  if (aInput) {
			query.searchTerms = aInput;
			sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
			resultType = NHQO.RESULTS_AS_URI;
		  }
		  else {
			switch (gHistoryGrouping) {
			  case 'visited':
				resultType = NHQO.RESULTS_AS_URI;
				sortingMode = NHQO.SORT_BY_VISITCOUNT_DESCENDING;
				break; 
			  case 'lastvisited':
				resultType = NHQO.RESULTS_AS_URI;
				sortingMode = NHQO.SORT_BY_DATE_DESCENDING;
				break; 
			  case 'dayandsite':
				resultType = NHQO.RESULTS_AS_DATE_SITE_QUERY;
				break;
			  case 'site':
				resultType = NHQO.RESULTS_AS_SITE_QUERY;
				sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
				break;
			  case 'day':
			  default:
				resultType = NHQO.RESULTS_AS_DATE_QUERY;
				break;
			}
		  }
		  options.sortingMode = sortingMode;
		  options.resultType = resultType;
		  gHistoryTree.load([query], options);
		}
		HistorySidebarInit();
	},
	
	 SU_handleTreeClick : function(aTree, aEvent, aGutterSelect) {
		if (aEvent.button == 2)
		  return;
		var tbo = aTree.treeBoxObject;
		var row = { }, col = { }, obj = { };
		tbo.getCellAt(aEvent.clientX, aEvent.clientY, row, col, obj);
		if (row.value == -1 || obj.value == 'twisty')
		  return;
		var mouseInGutter = false;
		if (aGutterSelect) {
		  var x = { }, y = { }, w = { }, h = { };
		  tbo.getCoordsForCellItem(row.value, col.value, 'image', x, y, w, h);
		  mouseInGutter = aEvent.clientX < x.value;
		}
		var modifKey = aEvent.ctrlKey || aEvent.shiftKey;
		var isContainer = tbo.view.isContainer(row.value);
		var openInTabs = isContainer &&
			 (aEvent.button == 1 ||
			  (aEvent.button == 0 && modifKey)) &&
			 PlacesUtils.hasChildURIs(tbo.view.nodeForTreeIndex(row.value));
		if (aEvent.button == 0 && isContainer && !openInTabs) {
		  tbo.view.toggleOpenState(row.value);
		  return;
		}
		else if (!mouseInGutter && openInTabs &&
				aEvent.originalTarget.localName == 'treechildren') {
		  tbo.view.selection.select(row.value);
		  PlacesUIUtils.openContainerNodeInTabs(aTree.selectedNode, aEvent);
		}
		else if (!mouseInGutter && !isContainer &&
				 aEvent.originalTarget.localName == 'treechildren') {
		  tbo.view.selection.select(row.value);
		  myTabBar.isNewTabCmd=true ;
		  PlacesUIUtils.openNodeWithEvent(aTree.selectedNode, aEvent);
		  myTabBar.isNewTabCmd=false ;
			if(aEvent.button == 0){
				if (aTree.selectedNode && PlacesUtils.nodeIsURI(aTree.selectedNode) ) {
					document.getElementById('myPanel').hidePopup() ;
				}
			}
		}
	} ,

	searchHistory :function searchHistory(aInput)
	{
	  var query = PlacesUtils.history.getNewQuery();
	  var options = PlacesUtils.history.getNewQueryOptions();
	  const NHQO = Ci.nsINavHistoryQueryOptions;
	  var sortingMode;
	  var resultType;
	  if (aInput) {
		query.searchTerms = aInput;
		sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
		resultType = NHQO.RESULTS_AS_URI;
	  }
	  else {
		gSearchBox = document.getElementById('search-box');
		gSearchBox.value='' ;
		gHistoryGrouping = document.getElementById('viewButton').getAttribute('selectedsort1');
		switch (gHistoryGrouping) {
		  case 'visited':
			resultType = NHQO.RESULTS_AS_URI;
			sortingMode = NHQO.SORT_BY_VISITCOUNT_DESCENDING;
			break; 
		  case 'lastvisited':
			resultType = NHQO.RESULTS_AS_URI;
			sortingMode = NHQO.SORT_BY_DATE_DESCENDING;
			break; 
		  case 'dayandsite':
			resultType = NHQO.RESULTS_AS_DATE_SITE_QUERY;
			break;
		  case 'site':
			resultType = NHQO.RESULTS_AS_SITE_QUERY;
			sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
			break;
		  case 'day':
		  default:
			resultType = NHQO.RESULTS_AS_DATE_QUERY;
			break;
			}
		}
		options.sortingMode = sortingMode;
		options.resultType = resultType;
		var gHistoryTree = document.getElementById('myHistoryTree');
		gHistoryTree.load([query], options);
	},
	
/* µǿ¼ӱǩҳ */	
/*-------------------------------------------------------------------------------------*/
//mySelectTabбťչť
//currentListmainBroadcasterSetпԴ򿪲б
//firstOpenCCCһεCCCʱ
//currentCmdǰѡťĴbrowserݵ
//imgListgToolbox.paletteõİťб
//imgIdListǰmySidebarBoxдŵİťб
//CurrentRadioǰѡĿؼ
//myGroupؼĸб
//isFocusǰpanelǷѻý
/*---------------------------------------------------------------------------------------*/

	mySelectTab :null ,
	nativeJSON : Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON),
	currentList : [] ,
	firstOpenCCC : true ,
	currentCmd :null ,
	imgList : null ,
	imgIdList:null ,
	sidebar :null,
	CurrentRadio : "" ,
	myGroup:null ,
	isFocus:false ,
	
	/* õmainBroadcasterSetеsidebarurllabel ,бŵcurrentList */
    getList : function(){
		var myList=null;
		//tabб { 'id':'' , 'title':''  , 'url':'' , 'used':'' ,"cmd" :"" }
		var currentList= myBookMarkJs.currentList  ;
		if(currentList.length != 0) {
			myList=currentList;
		}
		else{
			myList=[];
			var mainBcs = document.getElementById('mainBroadcasterSet') ;
			var passList="|viewBookmarksSidebar|viewHistorySidebar" ;
			for (var i=0 ;i < mainBcs.childNodes.length;i++){
				var n= mainBcs.childNodes[i] ;
				var tabId = n.getAttribute('id') ;
				if( n.hasAttribute('sidebarurl') && n.hasAttribute('label') && passList.indexOf(tabId) == -1 ){
					var tabUrl = n.getAttribute('sidebarurl') ;	
					if(n.hasAttribute('checked')) n.removeAttribute('checked') ;
					var tabLabel =n.getAttribute('label') ;
					var cmd =  n.getAttribute('oncommand') ;
					var isUsed =false ;
					var tab={
						'id': tabId , 
						'title': tabLabel ,
						'url': tabUrl ,
						'used': isUsed ,
						'cmd' : cmd
					}
					myList.push(tab); 
				}
			}
			myBookMarkJs.currentList= myList ; 
		}
		return myList ;
	},
	
	
	/*ô򿪲ĶӦ¼ */
	setTabCCC :function(myPanel) {
		if(!myBookMarkJs.sidebar) myBookMarkJs.sidebar=document.getElementById("mySidebar",myPanel);

		if(!myBookMarkJs.mySelectTab) myBookMarkJs.mySelectTab=document.getElementById('mySelectTab',myPanel);
		if(!myBookMarkJs.myGroup)	myBookMarkJs.myGroup= document.getElementById("myAddOnsGroup",myPanel);		
		if(!myBookMarkJs.imgIdList)	 
			myBookMarkJs.imgIdList=eval(document.getElementById("mySidebarBox",myPanel).getAttribute('imgIdList'));		
		if(!myBookMarkJs.imgIdList)	 myBookMarkJs.imgIdList =[] ;

		if(myPanel.getAttribute('firstOpen')=='true'){	
			var myList=myBookMarkJs.getList() ;
			if(myList.length >0 ) {
				var myTabCCC=document.getElementById('CCC') ;	
				myTabCCC.setAttribute('moz-collapsed', 'false');		
			}
			myPanel.setAttribute('firstOpen', 'false');	
		}
	},
	
	/*ԸĹرհť¼ */
	setSidebarCloseCmd : function(){
		var myCmd = " myBookMarkJs.onPanelClose('OpenSideBar') ; "	
		myCmd += "document.getElementById('myPanel').hidePopup() ; " ;
		var myBookMarksTabs=document.getElementById('myBookMarksTabs');
		var strCmd =myBookMarksTabs.getAttribute("value") ; 
		if(strCmd.length==0){
			var value=document.getElementById('myAddOnsGroup').getAttribute('currentRadio') ;
			if(value){
				strCmd = value ;
				if(cmd= strCmd.match(/.+(toggleSidebar.+)/)) strCmd = cmd[1] ;
			}
		}
		strCmd += myCmd  ;
		eval( strCmd );
	},
	
	/*Ƶbrowserʱbrowserвֵܴ */		
	mySideBarHideboxLoad : function(browser){
		if(!myBookMarkJs.isFocus){
			var mySideBarHidebox=document.getElementById('mySideBarHidebox') ;
			mySideBarHidebox.removeAttribute('src') ;
			mySideBarHidebox.setAttribute('src','chrome://global/skin/myFirefoxTab/myAddOnsHide.xul');
			myBookMarkJs.isFocus=true ;	
		}

	},

	/*CCCťʱ */	
	openAddOnsPanel : function(){
		if(myBookMarkJs.firstOpenCCC){
			myBookMarkJs.setTabButtons();
			myBookMarkJs.firstOpenCCC=false ;
		}
	},
	/* gToolbox.palette еõtoolbarButtonб */	
	getImageList : function(){	
		var list=[] ;
		var gToolbox= document.getElementById("navigator-toolbox");	
		var n = gToolbox.palette.firstChild;
		while (n) {
			if(n.hasAttribute('label') && n.hasAttribute('oncommand') ){
				var newItem={'label':n.getAttribute('label'), 'id':n.id , 'class':n.getAttribute('class')}
				list.push(newItem);
			}
		    n = n.nextSibling;
		}
		myBookMarkJs.imgList=list ;		
	},

	/*mySelectTabťPopupֵ */
	cteateTabPopMenu : function(){
		var tabPopup =document.getElementById("selectTabPop");	
		while(tabPopup.firstChild) tabPopup.removeChild(tabPopup.firstChild);
		var selectedTabs =  document.getElementById('mySelectTab').getAttribute("selectedTabs") ;
		var myList=myBookMarkJs.getList() ;
		for (var i=0 ;i<myList.length ;i++){
			var list=myList[i] ;
			if (selectedTabs.indexOf(list.id) > 0) list.used=true ;
			var m = document.createElement('menuitem');
			m.setAttribute('id',  "tabList" + i);				
			m.setAttribute('label', list.title );
			m.setAttribute('type', 'checkbox');
			m.setAttribute('value', i);	
			m.setAttribute('checked',list.used);				
			m.setAttribute('oncommand',"myBookMarkJs.menuChaged(this , '"+list.title + "','" +list.url +"');");
			tabPopup.appendChild(m) ;			
		}
	},
		
	/*ѡ˲˵󴥷,ӻtabҳ */
	menuChaged : function (menuItem ,title ,url) {
		var SelectTab=myBookMarkJs.mySelectTab ;
		var n=menuItem.getAttribute('value') ;		
		myBookMarkJs.currentList[n].used =!myBookMarkJs.currentList[n].used ;		
		var strSelectTab=SelectTab.getAttribute("selectedTabs");
		var strId="|" + myBookMarkJs.currentList[n].id  ;		
		strSelectTab=strSelectTab.replace(strId,"") ;
		if(myBookMarkJs.currentList[n].used) strSelectTab += strId ;
		
		SelectTab.setAttribute("selectedTabs",strSelectTab);
		myBookMarkJs.setTabButtons() ;
	},

	/*ͨmySelectTabťȡselectedTabsֵ,жϵǰѡеб. */
	setTabButtons : function(){
		var myGroup=myBookMarkJs.myGroup ;
		myBookMarkJs.CurrentRadio=myGroup.getAttribute('currentRadio') ;
		myGroup.setAttribute("value",null);				
		while(myGroup.firstChild) myGroup.removeChild(myGroup.firstChild);
	
		myBookMarkJs.currentCmd=null ;		
		
		var myList=[] ;
		var currentList= myBookMarkJs.currentList ;
		for(n in currentList) myList.push(currentList[n]);
		
		var imgList=[];
		var list=myBookMarkJs.imgIdList ;
		for(n in list)	imgList.push(list[n]);
				
		var mySelectTab=myBookMarkJs.mySelectTab ;		
		var strSelectTab=mySelectTab.getAttribute("selectedTabs");		
		var arr=strSelectTab.split("|");
		for (var i=1 ;i<arr.length ;i++){
			for (j in myList){
				var list = myList[j];
				if(arr[i]==list.id) {
					myBookMarkJs.AddRadio(myGroup,list,imgList) ;
					myList.splice(j,1);
					break;
				}
			}				
		}
		if(myBookMarkJs.currentCmd ) eval(myBookMarkJs.currentCmd);			
		else myBookMarkJs.myToggleSidebar("about:blank") ;

	},
	
	/*myBookMarksTabstab,öӦĹرpanel */
	AddRadio :function(group,list,imgList){
		var myGroup= group ; 
		var cmd= "myBookMarkJs.myToggleSidebar('" + list.url + "');" ;	
		var myImag=myBookMarkJs.getImg(list.title,imgList) ;
		var r = document.createElement('toolbarbutton');
		r.setAttribute('id', myImag.id );
		r.setAttribute('class',myImag.class );				
		r.setAttribute('tooltiptext',list.title );
		r.setAttribute('url',  list.url );		
		r.setAttribute('type', "radio" );
		r.setAttribute('value', list.cmd );				
		r.setAttribute('group', "myAddOnsGroup" );
		r.setAttribute("oncommand","myBookMarkJs.ButtonClick(this)");
		if( list.cmd== myBookMarkJs.CurrentRadio){
			r.setAttribute("checked",true);
			myBookMarkJs.currentCmd=cmd ;
		}
		myGroup.appendChild(r);	
		return;
	},
	
	
	ButtonClick :function(button){
		var currentRadio=button.parentNode.getAttribute('currentRadio') ;
		var value =button.getAttribute('value' ) ;
		if(currentRadio!=value ) {
			myBookMarkJs.myToggleSidebar(button.getAttribute("url")) ;	
			button.parentNode.setAttribute('currentRadio',button.getAttribute('value' )) ;
		}
		else 
		{
			myBookMarkJs.myToggleSidebar("about:blank") ;	
			button.parentNode.setAttribute('currentRadio',"") ;	
			button.removeAttribute('checked') ;	
		}
	},

	
	/* labelõӦId,ԻͼƬ */
	getImg :function(label , imgList){
		var img=null ;
		for (var i=0 ;i< imgList.length; i++){
			var n=imgList[i] ;
			if(label==n.label){
				img=n;
				imgList.splice(i,1);
				break ;
			}
		}
		if(!img) {
			imgList= myBookMarkJs.imgList ;
			for (var i=0 ;i< imgList.length; i++){
				var n=imgList[i] ;
				if(label==n.label){
					img=n;
					myBookMarkJs.imgIdList.push(n) ;
					var mySidebarBox = document.getElementById("mySidebarBox") ;
					if(myBookMarkJs.imgIdList.length >=15) mySidebarBox.setAttribute('imgIdList' ,"") ;
					else mySidebarBox.setAttribute('imgIdList',myBookMarkJs.nativeJSON.encode(myBookMarkJs.imgIdList)) ;
					break ;
				}
			}
		}
		return img ;		
	},

	/*tabʾӦ */	
	myToggleSidebar : function ( myUrl ) {
		sidebar=myBookMarkJs.sidebar ;
		sidebar.setAttribute("src", myUrl);
	},	
	
 }
myBookMarkJs.getList() ;
myBookMarkJs.getImageList();
