//        
//Fly_world ơ 

var myTabBar = {
	isNewTabCmd : false ,
	isFirstRun : true,
	colorList :[
		{name : "green" },
		{name : "purple"},	
		{name : "yellow" },
		{name : "pink" }		
	],
	currenColor : -1 ,
	getColor : function(){
		myTabBar.currenColor +=1 ;
		if (myTabBar.currenColor >= myTabBar.colorList.length)  myTabBar.currenColor=0 ;
		var color= myTabBar.colorList[myTabBar.currenColor].name ;
		return color;
	},
	
	init : function () {
		function TabAdded(event){
			if(myTabBar.isFirstRun){
				myTabBar.setTabWidth() ;
				myTabBar.isFirstRun=false ;
			}
			if(myTabBar.isNewTabCmd) return ;
		
			var tab = event.target;
			var tabBox=gBrowser.tabContainer;
			var curTab=tabBox.childNodes[tabBox.selectedIndex] ;
			var color=null ;

			if(!curTab.hasAttribute("color") || curTab.getAttribute("color")=="default"){
				myTabBar.isNewTabCmd=true ;
				gBrowser.moveTabTo(tab,tabBox.selectedIndex+1) ;
				myTabBar.isNewTabCmd=false ;
				color=myTabBar.getColor() ;
				curTab.setAttribute("color",color) ;
				tab.setAttribute("color",color ) ;			 
			}
			else {
				color=curTab.getAttribute("color") ;
				var nextTab=curTab.nextSibling ;
				var no=1 ;
				while(nextTab && nextTab.getAttribute("color")==color) {
					nextTab=nextTab.nextSibling ;
					no++ ;
				}
				if(nextTab){
					var index=tabBox.selectedIndex + no ;
					if(index < tabBox.childNodes.length-1){
						myTabBar.isNewTabCmd=true ;
						gBrowser.moveTabTo(tab,index) ;
						myTabBar.isNewTabCmd=false ;
					}				
				}
				tab.setAttribute("color",color );
			}
	   }
		
		function TabMoved(event)
		{
			if(	myTabBar.isNewTabCmd) return ;
			var tab =event.target ;
			var color=tab.getAttribute("color") ;
			var preTab=tab.previousSibling;	
			var nextTab=tab.nextSibling ;
			
			if(preTab && nextTab && preTab.getAttribute("color")==nextTab.getAttribute("color") ){
				tab.setAttribute("color", preTab.getAttribute("color") ) ;
				return ;
			}
			if(!preTab && color!=nextTab.getAttribute("color")){	
				tab.setAttribute("color", "default" ) ;
				return ;
			}			
			if(!nextTab && color!=preTab.getAttribute("color")){
				tab.setAttribute("color", "default" ) ;
				return ;
			}
			if(preTab && nextTab && color!=preTab.getAttribute("color") && color!=nextTab.getAttribute("color")){
				tab.setAttribute("color", "default" ) ;
				return ;
			}				
		}
		
		function TabRemoved(event)
		{
			var tab =event.target ;
			var color=tab.getAttribute("color") ;			
			if(!tab.hasAttribute("color") || color=="default") return ;

			var preTab=tab.previousSibling;			
			var nextTab=tab.nextSibling ;
			
			if(!nextTab || (nextTab &&  nextTab.getAttribute("color") !=color) ){
				var startTab=preTab.previousSibling;
				if(!startTab || startTab.getAttribute("color") !=color) preTab.setAttribute("color","default" ) ;
				return ;				
			}
			
			if(!preTab || (preTab && preTab.getAttribute("color") !=color)) {
				var endTab=nextTab.nextSibling ;
				if(!endTab || endTab.getAttribute("color") !=color) nextTab.setAttribute("color","default" ) ;
				return ;
			}
		}
		
		// During initialisation
		var container = gBrowser.tabContainer;
		container.addEventListener("TabOpen", TabAdded, false);
		container.addEventListener("TabMove", TabMoved, false);
		container.addEventListener("TabClose", TabRemoved, false);
		container.addEventListener("TabClose", TabRemoved, false);	
		var myTabBarNewButton = document.getElementById('myTabBarNewButton' , gBrowser) ;
		myTabBarNewButton.command="" ;
		myTabBarNewButton.setAttribute("oncommand","myTabBar.addNewTab();") ;			
		document.getElementById('cmd_newNavigatorTab').setAttribute("oncommand","myTabBar.addNewTab();") ;
	},
	
	addNewTab : function () {	
		myTabBar.isNewTabCmd=true ;
		BrowserOpenTab();
		myTabBar.isNewTabCmd=false ;			
		var tab = gBrowser.tabContainer.lastChild;
		tab.setAttribute("color","default") ;	
	},
	
	/*µsetTabWidthcopyMerci chaoֵmyfxVa,ش ( Ҿ͵XD )   */	
	setTabWidth :  function () {
		tabbar=gBrowser.tabContainer;
		if(tabbar.hasAttribute("one-tab")) return ;
		tabbar.addEventListener("DOMAttrModified", function(event){
			//add "one-tab" attribute to show if there is only one tab
			var onetab = this.childNodes.length == 1;
			this.setAttribute("one-tab", onetab);
	
			//make the width of tabs become the same of IE
			for (var item=this.firstChild; item; item=item.nextSibling) {
				item.setAttribute("maxwidth", onetab ? 302 : item == this.firstChild ? 183 : 180);
				item.setAttribute("minwidth", onetab ? 170 : item == this.firstChild ? 64 : 61);
			}
		}, true);		
	}
};
myTabBar.init() ;